﻿Imports vsto = Microsoft.Office.Interop.Excel

Public Class ThisAddIn

    Private Sub ThisAddIn_Startup() Handles Me.Startup

        Dim myTaskPane = New TaskPane
        Dim myCustomTaskPane = Me.CustomTaskPanes.Add(myTaskPane, "SQL To Excel Task Pane")
        myCustomTaskPane.Visible = True

        AddHandler myTaskPane.MakeTable, AddressOf myTaskPane_MakeTable
        AddHandler myTaskPane.MakePivot, AddressOf myTaskPane_MakePivot

        AddHandler myTaskPane.SaveAsUnique, AddressOf myTaskPane_SaveAsUnique
        AddHandler myTaskPane.CopyScript, AddressOf myTaskPane_CopyScript

    End Sub


    Private ReadOnly Property TheActiveWorkbook() As vsto.Workbook
        Get

            If Globals.ThisAddIn.Application.ActiveWorkbook Is Nothing Then
                Globals.ThisAddIn.Application.Workbooks.Add()
            End If

            Return Globals.ThisAddIn.Application.ActiveWorkbook

        End Get
    End Property

    Private ReadOnly Property TheActiveWorksheet() As vsto.Worksheet
        Get
            Return DirectCast(TheActiveWorkbook.ActiveSheet, Excel.Worksheet)
        End Get
    End Property

    Private ReadOnly Property TheSelection() As vsto.Range
        Get

            Dim areas = DirectCast(Globals.ThisAddIn.Application.Selection, Excel.Range).Areas

            If areas.Count = 1 Then
                Return areas(1)
            Else
                Return Nothing
            End If

        End Get
    End Property

#Region "Event Handlers"

    Private Sub myTaskPane_MakeTable(ByVal sender As Object, ByVal e As System.EventArgs)

        Using eh As New ExcelHelper
            eh.FillList(TheActiveWorksheet, CStr(sender))
        End Using

    End Sub

    Private Sub myTaskPane_MakePivot(ByVal sender As Object, ByVal e As System.EventArgs)

        Using eh As New ExcelHelper
            eh.fillPivot(TheActiveWorkbook, CStr(sender))
        End Using

    End Sub

    Private Sub myTaskPane_SaveAsUnique(ByVal sender As Object, ByVal e As System.EventArgs)

        Dim path = String.Format("{0}\{1}.xlsx", My.Computer.FileSystem.SpecialDirectories.MyDocuments, Guid.NewGuid.ToString)
        TheActiveWorkbook.SaveAs(Filename:=path)

    End Sub

    Private Sub myTaskPane_CopyScript(ByVal sender As Object, ByVal e As System.EventArgs)

        Using e2s As New ExcelToSql(DirectCast(Application.Selection, Excel.Range))
            My.Computer.Clipboard.SetText(e2s.Script)
        End Using

    End Sub

#End Region


End Class
